' ---------------------------------------------------------------------------------------
'
' MoltkeNET.VB                                                     Ulrich Mller 20.09.02
'                                                                  PCS1700   VB.NET Final
' Moltke Patience (H. Juhl : Neue Patiencen Seite 36 ff.)
' Entwickelt nach der VB6-Version vom 16.9.99, zustzlich BlockDrag
' Das eigentliche Spiel liegt in der Klasse MolPatience
' Basis sind PotiPat.DLL und QCard32.DLL
' 
' ---------------------------------------------------------------------------------------

Imports PotiPat

Public Class frmMain
  Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

  Public Sub New()
    MyBase.New()

    ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
    InitializeComponent()

    ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

  End Sub

  ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Fr Windows Form-Designer erforderlich
  Private components As System.ComponentModel.IContainer

  'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
  'Sie kann mit dem Windows Form-Designer modifiziert werden.
  'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents lblTitel As System.Windows.Forms.Label
  Friend WithEvents mnuMain As System.Windows.Forms.MainMenu
  Friend WithEvents mnuEnde As System.Windows.Forms.MenuItem
  Friend WithEvents mnuSpiel As System.Windows.Forms.MenuItem
  Friend WithEvents mnuNeu As System.Windows.Forms.MenuItem
  Friend WithEvents mnuWahl As System.Windows.Forms.MenuItem
  Friend WithEvents mnuNext As System.Windows.Forms.MenuItem
  Friend WithEvents mnuWieder As System.Windows.Forms.MenuItem
  Friend WithEvents mnuDummy1 As System.Windows.Forms.MenuItem
  Friend WithEvents mnuOptionen As System.Windows.Forms.MenuItem
  Friend WithEvents mnuStatistik As System.Windows.Forms.MenuItem
  Friend WithEvents mnuScoreBoard As System.Windows.Forms.MenuItem
  Friend WithEvents mnuHilfe As System.Windows.Forms.MenuItem
  Friend WithEvents mnuIndex As System.Windows.Forms.MenuItem
  Friend WithEvents mnuAbout As System.Windows.Forms.MenuItem
  Friend WithEvents lblAblage As System.Windows.Forms.Label
  Friend WithEvents lblTalon As System.Windows.Forms.Label
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmMain))
    Me.lblTitel = New System.Windows.Forms.Label()
    Me.mnuMain = New System.Windows.Forms.MainMenu()
    Me.mnuSpiel = New System.Windows.Forms.MenuItem()
    Me.mnuNeu = New System.Windows.Forms.MenuItem()
    Me.mnuWahl = New System.Windows.Forms.MenuItem()
    Me.mnuNext = New System.Windows.Forms.MenuItem()
    Me.mnuWieder = New System.Windows.Forms.MenuItem()
    Me.mnuDummy1 = New System.Windows.Forms.MenuItem()
    Me.mnuEnde = New System.Windows.Forms.MenuItem()
    Me.mnuOptionen = New System.Windows.Forms.MenuItem()
    Me.mnuStatistik = New System.Windows.Forms.MenuItem()
    Me.mnuScoreBoard = New System.Windows.Forms.MenuItem()
    Me.mnuHilfe = New System.Windows.Forms.MenuItem()
    Me.mnuIndex = New System.Windows.Forms.MenuItem()
    Me.mnuAbout = New System.Windows.Forms.MenuItem()
    Me.lblAblage = New System.Windows.Forms.Label()
    Me.lblTalon = New System.Windows.Forms.Label()
    Me.SuspendLayout()
    '
    'lblTitel
    '
    Me.lblTitel.Font = New System.Drawing.Font("Comic Sans MS", 24.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblTitel.ForeColor = System.Drawing.SystemColors.ActiveCaptionText
    Me.lblTitel.Location = New System.Drawing.Point(248, 160)
    Me.lblTitel.Name = "lblTitel"
    Me.lblTitel.Size = New System.Drawing.Size(232, 176)
    Me.lblTitel.TabIndex = 0
    Me.lblTitel.Text = "This is the Famous Moltke Patience"
    Me.lblTitel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
    '
    'mnuMain
    '
    Me.mnuMain.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuSpiel, Me.mnuOptionen, Me.mnuHilfe})
    '
    'mnuSpiel
    '
    Me.mnuSpiel.Index = 0
    Me.mnuSpiel.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuNeu, Me.mnuWahl, Me.mnuNext, Me.mnuWieder, Me.mnuDummy1, Me.mnuEnde})
    Me.mnuSpiel.Text = "&Spiel"
    '
    'mnuNeu
    '
    Me.mnuNeu.Index = 0
    Me.mnuNeu.Shortcut = System.Windows.Forms.Shortcut.F2
    Me.mnuNeu.Text = "&Neues Spiel"
    '
    'mnuWahl
    '
    Me.mnuWahl.Index = 1
    Me.mnuWahl.Shortcut = System.Windows.Forms.Shortcut.F3
    Me.mnuWahl.Text = "Spiel &Auswahl"
    '
    'mnuNext
    '
    Me.mnuNext.Index = 2
    Me.mnuNext.Shortcut = System.Windows.Forms.Shortcut.F7
    Me.mnuNext.Text = "N&chstes Spiel"
    '
    'mnuWieder
    '
    Me.mnuWieder.Enabled = False
    Me.mnuWieder.Index = 3
    Me.mnuWieder.Shortcut = System.Windows.Forms.Shortcut.F5
    Me.mnuWieder.Text = "Spiel &Wiederholen"
    '
    'mnuDummy1
    '
    Me.mnuDummy1.Index = 4
    Me.mnuDummy1.Text = "-"
    '
    'mnuEnde
    '
    Me.mnuEnde.Index = 5
    Me.mnuEnde.Text = "B&eenden"
    '
    'mnuOptionen
    '
    Me.mnuOptionen.Index = 1
    Me.mnuOptionen.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuStatistik, Me.mnuScoreBoard})
    Me.mnuOptionen.Text = "&Optionen"
    '
    'mnuStatistik
    '
    Me.mnuStatistik.Index = 0
    Me.mnuStatistik.Shortcut = System.Windows.Forms.Shortcut.F4
    Me.mnuStatistik.Text = "&Statistik"
    '
    'mnuScoreBoard
    '
    Me.mnuScoreBoard.Index = 1
    Me.mnuScoreBoard.Shortcut = System.Windows.Forms.Shortcut.F6
    Me.mnuScoreBoard.Text = "Score&Board"
    '
    'mnuHilfe
    '
    Me.mnuHilfe.Index = 2
    Me.mnuHilfe.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuIndex, Me.mnuAbout})
    Me.mnuHilfe.Text = "&Hilfe"
    '
    'mnuIndex
    '
    Me.mnuIndex.Index = 0
    Me.mnuIndex.Text = "&Index"
    '
    'mnuAbout
    '
    Me.mnuAbout.Index = 1
    Me.mnuAbout.Text = "&About"
    '
    'lblAblage
    '
    Me.lblAblage.Font = New System.Drawing.Font("Arial", 15.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblAblage.Location = New System.Drawing.Point(344, 40)
    Me.lblAblage.Name = "lblAblage"
    Me.lblAblage.Size = New System.Drawing.Size(56, 24)
    Me.lblAblage.TabIndex = 1
    Me.lblAblage.Text = "104"
    Me.lblAblage.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
    Me.lblAblage.Visible = False
    '
    'lblTalon
    '
    Me.lblTalon.Location = New System.Drawing.Point(360, 80)
    Me.lblTalon.Name = "lblTalon"
    Me.lblTalon.Size = New System.Drawing.Size(24, 16)
    Me.lblTalon.TabIndex = 2
    Me.lblTalon.Text = "54"
    Me.lblTalon.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
    Me.lblTalon.Visible = False
    '
    'frmMain
    '
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.BackColor = System.Drawing.Color.Green
    Me.ClientSize = New System.Drawing.Size(712, 489)
    Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblTalon, Me.lblAblage, Me.lblTitel})
    Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
    Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
    Me.MaximizeBox = False
    Me.Menu = Me.mnuMain
    Me.Name = "frmMain"
    Me.Text = "Moltke.NET"
    Me.ResumeLayout(False)

  End Sub

#End Region

  Dim WithEvents mp As MolPatience
  Dim ArbeitsMode% = 0
  Dim SpielNr%
  Dim Seed As New Random()
  Dim IniName$ = New IO.DirectoryInfo(".\").FullName & "Moltke.DAT"
  Dim gp As GlobaleDaten
  Dim About As frmAbout = New frmAbout()

  ' -------------- Standard Form-Ereignisse ------------------------------------------

  Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) _
    Handles MyBase.Load

    ' --- QCard32.DLL initialisieren ------------------------------------------
    Try
      mp = New MolPatience(Me, lblAblage, lblTalon)
    Catch em As MolException
      MessageBox.Show(em.Message, "Moltke.NET")
      Me.Close()
    End Try

    ' --------------- Persistente Daten ----------------------------------------
    If IO.File.Exists(IniName) Then
      Dim ser As New Runtime.Serialization.Formatters.Binary.BinaryFormatter()
      Dim bin As New IO.FileStream(IniName, IO.FileMode.Open)
      gp = CType(ser.Deserialize(bin), GlobaleDaten)
      bin.Close()
    Else
      gp = New GlobaleDaten()
      gp.LastVisit = Now
    End If
    Me.Width = 784
    Me.Height = 740
    Me.Left = gp.FormLeft
    Me.Top = gp.FormTop
    Randomize()
    mp.Back = gp.BackNr
    SpielNr = gp.KartenSeed
  End Sub

  Private Sub frmMain_Closed(ByVal sender As Object, _
                             ByVal e As System.EventArgs) Handles MyBase.Closed
    ' ----------- Persistente Daten ----------------------------------------
    Dim ser As New Runtime.Serialization.Formatters.Binary.BinaryFormatter()
    Dim bin As New IO.FileStream(IniName, IO.FileMode.Create)
    gp.FormLeft = Me.Left
    gp.FormTop = Me.Top
    gp.KartenSeed = SpielNr
    gp.LastVisit = Now
    gp.BackNr = mp.Back
    ser.Serialize(bin, gp)
    bin.Close()
  End Sub

  Private Sub frmMain_Paint(ByVal sender As Object, _
                 ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

    If ArbeitsMode > 0 Then mp.Refresh()
  End Sub

  Private Sub mnuEnde_Click(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles mnuEnde.Click
    Me.Close()
  End Sub

  ' --------------- Maus-Ereignisse ---------------------------------------------------

  Private Sub frmMain_MouseDown(ByVal sender As Object, _
             ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown

    mp.StartZiehen(e.X, e.Y)
  End Sub

  Private Sub frmMain_MouseMove(ByVal sender As Object, _
             ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove

    mp.WeiterZiehen(e.X, e.Y)
  End Sub

  Private Sub frmMain_MouseUp(ByVal sender As Object, _
               ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp

    mp.EndeZiehen(e.X, e.Y)
  End Sub

  Private Sub frmMain_DoubleClick(ByVal sender As Object, _
                              ByVal e As System.EventArgs) Handles MyBase.DoubleClick
    mp.KarteAblegen()
  End Sub

  ' ---------------------- Gewonnen-Ereignis -------------------------------------------

  Private Sub mp_GameWon(ByVal Pati As Moltke.NET.MolPatience) Handles mp.GameWon
    gp.GamesWon += 1
    lblTitel.Text = "Gewonnen"
    lblTitel.Visible = True
  End Sub

  ' ------------- Menu-Event-Routinen -----------------------------------------------

  Private Sub mnuNeu_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
     Handles mnuNeu.Click
    lblTitel.Visible = False
    Me.Refresh()
    SpielNr = Seed.Next(1, 16000)
    Me.Text = "Moltke.NET : " & SpielNr
    gp.GamesTotal += 1
    mp.SpielStarten(SpielNr)
    ArbeitsMode = 1
    mnuWieder.Enabled = True
  End Sub

  Private Sub mnuNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
     Handles mnuNext.Click
    lblTitel.Visible = False
    Me.Refresh()
    SpielNr += 1
    Me.Text = "Moltke.NET : " & SpielNr
    gp.GamesTotal += 1
    mp.SpielStarten(SpielNr)
    ArbeitsMode = 1
    mnuWieder.Enabled = True
  End Sub

  Private Sub mnuWahl_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                Handles mnuWahl.Click

    SpielNr = Val(InputBox("Bitte ein Spiel whlen", "Moltke.NET", SpielNr, _
       Me.Left + 50, Me.Top + 80))
    lblTitel.Visible = False
    Me.Refresh()
    Me.Text = "Moltke.NET : " & SpielNr
    gp.GamesTotal += 1
    mp.SpielStarten(SpielNr)
    ArbeitsMode = 1
    mnuWieder.Enabled = True
  End Sub

  Private Sub mnuWieder_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                               Handles mnuWieder.Click
    lblTitel.Visible = False
    Me.Refresh()
    Me.Text = "Moltke.NET : " & SpielNr
    gp.GamesTotal += 1
    mp.SpielStarten(SpielNr)
    ArbeitsMode = 1
  End Sub

  Private Sub mnuAbout_Click(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                               Handles mnuAbout.Click
    About.ShowDialog()
  End Sub

  Private Sub mnuStatistik_Click(ByVal sender As System.Object, _
                                 ByVal e As System.EventArgs) Handles mnuStatistik.Click
    Dim Stat As New Statistik(gp)
    Stat.ShowDialog()
  End Sub

End Class
