' ---------------------------------------------------------------------------------------
'
' Statistik.VB                                                     Ulrich Mller 22.09.02
'                                                                  PCS1700   VB.NET Final
' Moltke.NET : Ausgabe Statistik-Daten
'
' ---------------------------------------------------------------------------------------
Public Class Statistik
  Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

  Public Sub New(ByVal gp As GlobaleDaten)
    MyBase.New()

    ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
    InitializeComponent()

    ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
    Me.gp = gp
  End Sub

  ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Fr Windows Form-Designer erforderlich
  Private components As System.ComponentModel.IContainer

  'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
  'Sie kann mit dem Windows Form-Designer modifiziert werden.
  'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents Label1 As System.Windows.Forms.Label
  Friend WithEvents lblGamesTotal As System.Windows.Forms.Label
  Friend WithEvents lblGamesWon As System.Windows.Forms.Label
  Friend WithEvents lblLastVisit As System.Windows.Forms.Label
  Friend WithEvents cmdEnde As System.Windows.Forms.Button
  Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Statistik))
    Me.Label1 = New System.Windows.Forms.Label()
    Me.lblGamesTotal = New System.Windows.Forms.Label()
    Me.lblGamesWon = New System.Windows.Forms.Label()
    Me.lblLastVisit = New System.Windows.Forms.Label()
    Me.cmdEnde = New System.Windows.Forms.Button()
    Me.PictureBox1 = New System.Windows.Forms.PictureBox()
    Me.SuspendLayout()
    '
    'Label1
    '
    Me.Label1.Font = New System.Drawing.Font("Comic Sans MS", 14.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.Label1.Location = New System.Drawing.Point(32, 32)
    Me.Label1.Name = "Label1"
    Me.Label1.Size = New System.Drawing.Size(288, 24)
    Me.Label1.TabIndex = 0
    Me.Label1.Text = "Moltke.NET - Statistik"
    '
    'lblGamesTotal
    '
    Me.lblGamesTotal.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblGamesTotal.Location = New System.Drawing.Point(48, 80)
    Me.lblGamesTotal.Name = "lblGamesTotal"
    Me.lblGamesTotal.Size = New System.Drawing.Size(232, 16)
    Me.lblGamesTotal.TabIndex = 1
    Me.lblGamesTotal.Text = "GesamtSpiele"
    '
    'lblGamesWon
    '
    Me.lblGamesWon.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblGamesWon.Location = New System.Drawing.Point(48, 112)
    Me.lblGamesWon.Name = "lblGamesWon"
    Me.lblGamesWon.Size = New System.Drawing.Size(232, 16)
    Me.lblGamesWon.TabIndex = 2
    Me.lblGamesWon.Text = "davon gewonnen"
    '
    'lblLastVisit
    '
    Me.lblLastVisit.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblLastVisit.Location = New System.Drawing.Point(48, 144)
    Me.lblLastVisit.Name = "lblLastVisit"
    Me.lblLastVisit.Size = New System.Drawing.Size(232, 16)
    Me.lblLastVisit.TabIndex = 3
    Me.lblLastVisit.Text = "Datum letzter Besuch"
    '
    'cmdEnde
    '
    Me.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel
    Me.cmdEnde.Location = New System.Drawing.Point(264, 200)
    Me.cmdEnde.Name = "cmdEnde"
    Me.cmdEnde.Size = New System.Drawing.Size(72, 24)
    Me.cmdEnde.TabIndex = 4
    Me.cmdEnde.Text = "&OK"
    '
    'PictureBox1
    '
    Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Bitmap)
    Me.PictureBox1.Location = New System.Drawing.Point(240, 80)
    Me.PictureBox1.Name = "PictureBox1"
    Me.PictureBox1.Size = New System.Drawing.Size(88, 88)
    Me.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage
    Me.PictureBox1.TabIndex = 5
    Me.PictureBox1.TabStop = False
    '
    'Statistik
    '
    Me.AcceptButton = Me.cmdEnde
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.CancelButton = Me.cmdEnde
    Me.ClientSize = New System.Drawing.Size(360, 245)
    Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.PictureBox1, Me.cmdEnde, Me.lblLastVisit, Me.lblGamesWon, Me.lblGamesTotal, Me.Label1})
    Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
    Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
    Me.MaximizeBox = False
    Me.Name = "Statistik"
    Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
    Me.Text = "Moltke.NET : Statistik"
    Me.ResumeLayout(False)

  End Sub

#End Region

  Private gp As GlobaleDaten

  Private Sub Statistik_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    lblGamesTotal.Text = "Anzahl Spiele gesamt : " & gp.GamesTotal
    lblGamesWon.Text = "davon gewonnen : " & gp.GamesWon
    lblLastVisit.Text = String.Format("Letzter Besuch {0:d}", gp.LastVisit)
  End Sub

End Class
